<?php

namespace Packs\Magento2\Model\Config\Source;

use Magento\Framework\View\Element\Template\Context;
use Packs\Magento2\Model\Export\Productinfo;

class SealOptions implements \Magento\Framework\Data\OptionSourceInterface
{

    protected $_productInfo;

    public function __construct(
        Context $context,
        Productinfo $productInfo
    ) {
        $this->_productInfo = $productInfo;
    }

    public function toOptionArray()
    {
        $options = array();
        $productOptions = $this->getProductInfo();
        if($productOptions){
            $i=0;
            foreach ($productOptions as $product => $option){
                $options[$i] = array(
                    'value' => strtolower($product),
                    'label' => $product,
                );
                $i++;
            }
        }else{
            $options[] = 'notloaded';
        }
        return $options;
    }


    public function getProductInfo(){
        return $this->_productInfo->getProductInfo();
    }
}
